Setup: nodejs, express, mongodb, mongoose

Relevant code:

var express = require('express'); var server = express(); server.use(express.bodyParser()); server.use(express.methodOverride()); server.use(server.router); var mongoose = require('mongoose'); mongoose.connect('localhost', 'test'); var Schema = mongoose.Schema; var VehicleSchema = new Schema({ name : String }, {collection: 'vehicles'}); var Vehicle = mongoose.model('vehicle', VehicleSchema); server.use(clientErrorHandler); function clientErrorHandler(err, req, res, next) { console.log('client error handler found', err); res.send(500, err); } server.get('/api/test', function(req, res, next){ Vehicle.find().exec(function(err, rows){ res.send(rows); }); }); server.listen(1981);

This will return an empty array as expected.

Throwing an exception here:

server.get('/api/test', function(req, res, next){ throw 'my exception';// <------------------------ here Vehicle.find().exec(function(err, rows){ res.send(rows); }); });

Works as expected with the clientErrorHandler catching the exception. Instead, throwing it here:

server.get('/api/test', function(req, res, next){ Vehicle.find().exec(function(err, rows){ throw 'my exception';// <------------------------ here res.send(rows); }); });

The exception is then not caught by the clientErrorHandler and is instead caught and rethrown by a mongoose/lib/util.js

exports.tick = function tick (callback) { if ('function' !== typeof callback) return; return function () { try { callback.apply(this, arguments); } catch (err) { // only nextTick on err to get out of // the event loop and avoid state corruption. process.nextTick(function () { throw err; //<--------------------------------- here }); } } }

Doing something without mongoose such as :

server.get('/api/test', function(req, res, next){ process.nextTick(function(){ throw 'here'; }); });

Also fails to be caught by express.

How do I avoid it being caught by mongoose instead of by express? How can I get express to catch the error? Can I get express to catch errors thrown on a separate tick? (Is this something I should report to express?)

I would like to avoid the process.error as I want to be able to send a message back to that user. I realize that one can call 'next' with an error, I'm more concerned about other exceptions that are from other libraries.

Problem courtesy of: Will Shaver

Solution

Rather than throwing an exception you should return an error with the next callback which can then be handled by your app’s error handler.

If you are calling functions that may throw their own errors, wrap them in a try clause and call the callback with the error you caught in catch . Here’s an example:

server.get('/api/test', function (req, res, next) { process.nextTick(function () { try { functionWhichWillThrowAnError(); } catch (error) { next(error); return; } res.send('everything is okay!'); }); });

Solution courtesy of: Todd Yandell

Discussion I realize that one can call 'next' with an error, I'm more concerned about other exceptions that are from other libraries.

I suspect you are concerned about this because your background with other programming languages (at least that was my case.) In the end it's unlikely you'll see exceptions in asynchronous code because that just not the convention in Node.js , it's still possible but unlikely. This is from Isaac Schlueter himself:

"The pattern in node is that sync methods throw, and async methods pass the error as the first argument to the callback. If the first argument to your callback is falsey (usually null or undefined), then all is well with the world." https://groups.google.com/d/msg/nodejs/W9UVJCKcJ7Q/rzseRbourCUJ

Discussion courtesy of: Hector Correa

This recipe can be found in it's original form on Stack Over Flow .

本文前端(javascript)相关术语:javascript是什么意思 javascript下载 javascript权威指南 javascript基础教程 javascript 正则表达式 javascript设计模式 javascript高级程序设计 精通javascript javascript教程

代码区博客精选文章
分页:12
转载请注明
本文标题:Can I get express error handler to catch exceptions thrown inside of a mongoose ...
本站链接:https://www.codesec.net/view/611507.html


1.凡CodeSecTeam转载的文章,均出自其它媒体或其他官网介绍,目的在于传递更多的信息,并不代表本站赞同其观点和其真实性负责;
2.转载的文章仅代表原创作者观点,与本站无关。其原创性以及文中陈述文字和内容未经本站证实,本站对该文以及其中全部或者部分内容、文字的真实性、完整性、及时性,不作出任何保证或承若;
3.如本站转载稿涉及版权等问题,请作者及时联系本站,我们会及时处理。
登录后可拥有收藏文章、关注作者等权限...
技术大类 技术大类 | 前端(javascript) | 评论(0) | 阅读(65)